from fred_api.registry import common_types_pb2 as _common_types_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class ContactId(_message.Message):
    __slots__ = ("uuid",)
    UUID_FIELD_NUMBER: _ClassVar[int]
    uuid: _common_types_pb2.Uuid
    def __init__(self, uuid: _Optional[_Union[_common_types_pb2.Uuid, _Mapping]] = ...) -> None: ...

class ContactHistoryId(_message.Message):
    __slots__ = ("uuid",)
    UUID_FIELD_NUMBER: _ClassVar[int]
    uuid: _common_types_pb2.Uuid
    def __init__(self, uuid: _Optional[_Union[_common_types_pb2.Uuid, _Mapping]] = ...) -> None: ...

class ContactHandle(_message.Message):
    __slots__ = ("value",)
    VALUE_FIELD_NUMBER: _ClassVar[int]
    value: str
    def __init__(self, value: _Optional[str] = ...) -> None: ...

class ContactRef(_message.Message):
    __slots__ = ("id", "handle", "name", "organization")
    ID_FIELD_NUMBER: _ClassVar[int]
    HANDLE_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    ORGANIZATION_FIELD_NUMBER: _ClassVar[int]
    id: ContactId
    handle: ContactHandle
    name: str
    organization: str
    def __init__(self, id: _Optional[_Union[ContactId, _Mapping]] = ..., handle: _Optional[_Union[ContactHandle, _Mapping]] = ..., name: _Optional[str] = ..., organization: _Optional[str] = ...) -> None: ...

class ContactHistoryInterval(_message.Message):
    __slots__ = ("lower_limit", "upper_limit")
    class Limit(_message.Message):
        __slots__ = ("timestamp", "contact_history_id")
        TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
        CONTACT_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
        timestamp: _timestamp_pb2.Timestamp
        contact_history_id: ContactHistoryId
        def __init__(self, timestamp: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., contact_history_id: _Optional[_Union[ContactHistoryId, _Mapping]] = ...) -> None: ...
    LOWER_LIMIT_FIELD_NUMBER: _ClassVar[int]
    UPPER_LIMIT_FIELD_NUMBER: _ClassVar[int]
    lower_limit: ContactHistoryInterval.Limit
    upper_limit: ContactHistoryInterval.Limit
    def __init__(self, lower_limit: _Optional[_Union[ContactHistoryInterval.Limit, _Mapping]] = ..., upper_limit: _Optional[_Union[ContactHistoryInterval.Limit, _Mapping]] = ...) -> None: ...

class NationalIdentityNumber(_message.Message):
    __slots__ = ("value",)
    VALUE_FIELD_NUMBER: _ClassVar[int]
    value: str
    def __init__(self, value: _Optional[str] = ...) -> None: ...

class NationalIdentityCard(_message.Message):
    __slots__ = ("value",)
    VALUE_FIELD_NUMBER: _ClassVar[int]
    value: str
    def __init__(self, value: _Optional[str] = ...) -> None: ...

class PassportNumber(_message.Message):
    __slots__ = ("value",)
    VALUE_FIELD_NUMBER: _ClassVar[int]
    value: str
    def __init__(self, value: _Optional[str] = ...) -> None: ...

class SocialSecurityNumber(_message.Message):
    __slots__ = ("value",)
    VALUE_FIELD_NUMBER: _ClassVar[int]
    value: str
    def __init__(self, value: _Optional[str] = ...) -> None: ...

class Birthdate(_message.Message):
    __slots__ = ("value",)
    VALUE_FIELD_NUMBER: _ClassVar[int]
    value: str
    def __init__(self, value: _Optional[str] = ...) -> None: ...

class ContactAdditionalIdentifier(_message.Message):
    __slots__ = ("national_identity_number", "national_identity_card", "passport_number", "company_registration_number", "social_security_number", "birthdate")
    NATIONAL_IDENTITY_NUMBER_FIELD_NUMBER: _ClassVar[int]
    NATIONAL_IDENTITY_CARD_FIELD_NUMBER: _ClassVar[int]
    PASSPORT_NUMBER_FIELD_NUMBER: _ClassVar[int]
    COMPANY_REGISTRATION_NUMBER_FIELD_NUMBER: _ClassVar[int]
    SOCIAL_SECURITY_NUMBER_FIELD_NUMBER: _ClassVar[int]
    BIRTHDATE_FIELD_NUMBER: _ClassVar[int]
    national_identity_number: NationalIdentityNumber
    national_identity_card: NationalIdentityCard
    passport_number: PassportNumber
    company_registration_number: _common_types_pb2.CompanyRegistrationNumber
    social_security_number: SocialSecurityNumber
    birthdate: Birthdate
    def __init__(self, national_identity_number: _Optional[_Union[NationalIdentityNumber, _Mapping]] = ..., national_identity_card: _Optional[_Union[NationalIdentityCard, _Mapping]] = ..., passport_number: _Optional[_Union[PassportNumber, _Mapping]] = ..., company_registration_number: _Optional[_Union[_common_types_pb2.CompanyRegistrationNumber, _Mapping]] = ..., social_security_number: _Optional[_Union[SocialSecurityNumber, _Mapping]] = ..., birthdate: _Optional[_Union[Birthdate, _Mapping]] = ...) -> None: ...

class ContactAddress(_message.Message):
    __slots__ = ("company", "street", "city", "state_or_province", "postal_code", "country_code")
    COMPANY_FIELD_NUMBER: _ClassVar[int]
    STREET_FIELD_NUMBER: _ClassVar[int]
    CITY_FIELD_NUMBER: _ClassVar[int]
    STATE_OR_PROVINCE_FIELD_NUMBER: _ClassVar[int]
    POSTAL_CODE_FIELD_NUMBER: _ClassVar[int]
    COUNTRY_CODE_FIELD_NUMBER: _ClassVar[int]
    company: str
    street: _containers.RepeatedScalarFieldContainer[str]
    city: str
    state_or_province: str
    postal_code: _common_types_pb2.PostalCode
    country_code: _common_types_pb2.CountryCode
    def __init__(self, company: _Optional[str] = ..., street: _Optional[_Iterable[str]] = ..., city: _Optional[str] = ..., state_or_province: _Optional[str] = ..., postal_code: _Optional[_Union[_common_types_pb2.PostalCode, _Mapping]] = ..., country_code: _Optional[_Union[_common_types_pb2.CountryCode, _Mapping]] = ...) -> None: ...

class WarningLetter(_message.Message):
    __slots__ = ("preference",)
    class SendingPreference(_message.Message):
        __slots__ = ()
        class Enum(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
            __slots__ = ()
            to_send: _ClassVar[WarningLetter.SendingPreference.Enum]
            not_to_send: _ClassVar[WarningLetter.SendingPreference.Enum]
            not_specified: _ClassVar[WarningLetter.SendingPreference.Enum]
        to_send: WarningLetter.SendingPreference.Enum
        not_to_send: WarningLetter.SendingPreference.Enum
        not_specified: WarningLetter.SendingPreference.Enum
        def __init__(self) -> None: ...
    PREFERENCE_FIELD_NUMBER: _ClassVar[int]
    preference: WarningLetter.SendingPreference.Enum
    def __init__(self, preference: _Optional[_Union[WarningLetter.SendingPreference.Enum, str]] = ...) -> None: ...
