from fred_api.registry.contact import contact_common_types_pb2 as _contact_common_types_pb2
from fred_api.registry import common_types_pb2 as _common_types_pb2
from fred_api.registry import error_types_pb2 as _error_types_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class ContactHistoryRequest(_message.Message):
    __slots__ = ("contact_id", "history")
    CONTACT_ID_FIELD_NUMBER: _ClassVar[int]
    HISTORY_FIELD_NUMBER: _ClassVar[int]
    contact_id: _contact_common_types_pb2.ContactId
    history: _contact_common_types_pb2.ContactHistoryInterval
    def __init__(self, contact_id: _Optional[_Union[_contact_common_types_pb2.ContactId, _Mapping]] = ..., history: _Optional[_Union[_contact_common_types_pb2.ContactHistoryInterval, _Mapping]] = ...) -> None: ...

class ContactHistoryRecord(_message.Message):
    __slots__ = ("contact_history_id", "valid_from", "log_entry_id")
    CONTACT_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
    VALID_FROM_FIELD_NUMBER: _ClassVar[int]
    LOG_ENTRY_ID_FIELD_NUMBER: _ClassVar[int]
    contact_history_id: _contact_common_types_pb2.ContactHistoryId
    valid_from: _timestamp_pb2.Timestamp
    log_entry_id: _common_types_pb2.LogEntryId
    def __init__(self, contact_history_id: _Optional[_Union[_contact_common_types_pb2.ContactHistoryId, _Mapping]] = ..., valid_from: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., log_entry_id: _Optional[_Union[_common_types_pb2.LogEntryId, _Mapping]] = ...) -> None: ...

class ContactHistoryReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("contact_id", "timeline", "valid_to")
        CONTACT_ID_FIELD_NUMBER: _ClassVar[int]
        TIMELINE_FIELD_NUMBER: _ClassVar[int]
        VALID_TO_FIELD_NUMBER: _ClassVar[int]
        contact_id: _contact_common_types_pb2.ContactId
        timeline: _containers.RepeatedCompositeFieldContainer[ContactHistoryRecord]
        valid_to: _timestamp_pb2.Timestamp
        def __init__(self, contact_id: _Optional[_Union[_contact_common_types_pb2.ContactId, _Mapping]] = ..., timeline: _Optional[_Iterable[_Union[ContactHistoryRecord, _Mapping]]] = ..., valid_to: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("contact_does_not_exist", "invalid_history_interval")
        class InvalidHistoryInterval(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        CONTACT_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        INVALID_HISTORY_INTERVAL_FIELD_NUMBER: _ClassVar[int]
        contact_does_not_exist: _error_types_pb2.ContactDoesNotExist
        invalid_history_interval: ContactHistoryReply.Exception.InvalidHistoryInterval
        def __init__(self, contact_does_not_exist: _Optional[_Union[_error_types_pb2.ContactDoesNotExist, _Mapping]] = ..., invalid_history_interval: _Optional[_Union[ContactHistoryReply.Exception.InvalidHistoryInterval, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: ContactHistoryReply.Data
    exception: ContactHistoryReply.Exception
    def __init__(self, data: _Optional[_Union[ContactHistoryReply.Data, _Mapping]] = ..., exception: _Optional[_Union[ContactHistoryReply.Exception, _Mapping]] = ...) -> None: ...
