from fred_api.registry import error_types_pb2 as _error_types_pb2
from fred_api.registry.contact import contact_common_types_pb2 as _contact_common_types_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class ContactStateHistoryRequest(_message.Message):
    __slots__ = ("contact_id", "history")
    CONTACT_ID_FIELD_NUMBER: _ClassVar[int]
    HISTORY_FIELD_NUMBER: _ClassVar[int]
    contact_id: _contact_common_types_pb2.ContactId
    history: _contact_common_types_pb2.ContactHistoryInterval
    def __init__(self, contact_id: _Optional[_Union[_contact_common_types_pb2.ContactId, _Mapping]] = ..., history: _Optional[_Union[_contact_common_types_pb2.ContactHistoryInterval, _Mapping]] = ...) -> None: ...

class ContactStateHistory(_message.Message):
    __slots__ = ("timeline", "valid_to")
    class Record(_message.Message):
        __slots__ = ("valid_from", "flags")
        class FlagsEntry(_message.Message):
            __slots__ = ("key", "value")
            KEY_FIELD_NUMBER: _ClassVar[int]
            VALUE_FIELD_NUMBER: _ClassVar[int]
            key: str
            value: bool
            def __init__(self, key: _Optional[str] = ..., value: bool = ...) -> None: ...
        VALID_FROM_FIELD_NUMBER: _ClassVar[int]
        FLAGS_FIELD_NUMBER: _ClassVar[int]
        valid_from: _timestamp_pb2.Timestamp
        flags: _containers.ScalarMap[str, bool]
        def __init__(self, valid_from: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., flags: _Optional[_Mapping[str, bool]] = ...) -> None: ...
    TIMELINE_FIELD_NUMBER: _ClassVar[int]
    VALID_TO_FIELD_NUMBER: _ClassVar[int]
    timeline: _containers.RepeatedCompositeFieldContainer[ContactStateHistory.Record]
    valid_to: _timestamp_pb2.Timestamp
    def __init__(self, timeline: _Optional[_Iterable[_Union[ContactStateHistory.Record, _Mapping]]] = ..., valid_to: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...

class ContactStateHistoryReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("contact_id", "history")
        CONTACT_ID_FIELD_NUMBER: _ClassVar[int]
        HISTORY_FIELD_NUMBER: _ClassVar[int]
        contact_id: _contact_common_types_pb2.ContactId
        history: ContactStateHistory
        def __init__(self, contact_id: _Optional[_Union[_contact_common_types_pb2.ContactId, _Mapping]] = ..., history: _Optional[_Union[ContactStateHistory, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("contact_does_not_exist", "invalid_history_interval")
        class InvalidHistoryInterval(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        CONTACT_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        INVALID_HISTORY_INTERVAL_FIELD_NUMBER: _ClassVar[int]
        contact_does_not_exist: _error_types_pb2.ContactDoesNotExist
        invalid_history_interval: ContactStateHistoryReply.Exception.InvalidHistoryInterval
        def __init__(self, contact_does_not_exist: _Optional[_Union[_error_types_pb2.ContactDoesNotExist, _Mapping]] = ..., invalid_history_interval: _Optional[_Union[ContactStateHistoryReply.Exception.InvalidHistoryInterval, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: ContactStateHistoryReply.Data
    exception: ContactStateHistoryReply.Exception
    def __init__(self, data: _Optional[_Union[ContactStateHistoryReply.Data, _Mapping]] = ..., exception: _Optional[_Union[ContactStateHistoryReply.Exception, _Mapping]] = ...) -> None: ...
