from fred_api.registry import common_types_pb2 as _common_types_pb2
from fred_api.registry import error_types_pb2 as _error_types_pb2
from fred_api.registry.domain import domain_common_types_pb2 as _domain_common_types_pb2
from fred_api.registry.registrar import registrar_common_types_pb2 as _registrar_common_types_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class DeleteDomainRequest(_message.Message):
    __slots__ = ("domain_id", "by_registrar", "snapshot_id")
    DOMAIN_ID_FIELD_NUMBER: _ClassVar[int]
    BY_REGISTRAR_FIELD_NUMBER: _ClassVar[int]
    SNAPSHOT_ID_FIELD_NUMBER: _ClassVar[int]
    domain_id: _domain_common_types_pb2.DomainId
    by_registrar: _registrar_common_types_pb2.RegistrarHandle
    snapshot_id: _common_types_pb2.SnapshotId
    def __init__(self, domain_id: _Optional[_Union[_domain_common_types_pb2.DomainId, _Mapping]] = ..., by_registrar: _Optional[_Union[_registrar_common_types_pb2.RegistrarHandle, _Mapping]] = ..., snapshot_id: _Optional[_Union[_common_types_pb2.SnapshotId, _Mapping]] = ...) -> None: ...

class DeleteDomainReply(_message.Message):
    __slots__ = ("data", "error")
    class Data(_message.Message):
        __slots__ = ("domain_history_id",)
        DOMAIN_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
        domain_history_id: _domain_common_types_pb2.DomainHistoryId
        def __init__(self, domain_history_id: _Optional[_Union[_domain_common_types_pb2.DomainHistoryId, _Mapping]] = ...) -> None: ...
    class Error(_message.Message):
        __slots__ = ("reasons",)
        class Reason(_message.Message):
            __slots__ = ("domain_blocked", "domain_does_not_exist", "invalid_snapshot", "invalid_value", "permission_denied", "registrar_does_not_exist")
            DOMAIN_BLOCKED_FIELD_NUMBER: _ClassVar[int]
            DOMAIN_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
            INVALID_SNAPSHOT_FIELD_NUMBER: _ClassVar[int]
            INVALID_VALUE_FIELD_NUMBER: _ClassVar[int]
            PERMISSION_DENIED_FIELD_NUMBER: _ClassVar[int]
            REGISTRAR_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
            domain_blocked: _error_types_pb2.DomainBlocked
            domain_does_not_exist: _error_types_pb2.DomainDoesNotExist
            invalid_snapshot: _error_types_pb2.InvalidSnapshot
            invalid_value: _error_types_pb2.InvalidValue
            permission_denied: _error_types_pb2.PermissionDenied
            registrar_does_not_exist: _error_types_pb2.RegistrarDoesNotExist
            def __init__(self, domain_blocked: _Optional[_Union[_error_types_pb2.DomainBlocked, _Mapping]] = ..., domain_does_not_exist: _Optional[_Union[_error_types_pb2.DomainDoesNotExist, _Mapping]] = ..., invalid_snapshot: _Optional[_Union[_error_types_pb2.InvalidSnapshot, _Mapping]] = ..., invalid_value: _Optional[_Union[_error_types_pb2.InvalidValue, _Mapping]] = ..., permission_denied: _Optional[_Union[_error_types_pb2.PermissionDenied, _Mapping]] = ..., registrar_does_not_exist: _Optional[_Union[_error_types_pb2.RegistrarDoesNotExist, _Mapping]] = ...) -> None: ...
        REASONS_FIELD_NUMBER: _ClassVar[int]
        reasons: _containers.RepeatedCompositeFieldContainer[DeleteDomainReply.Error.Reason]
        def __init__(self, reasons: _Optional[_Iterable[_Union[DeleteDomainReply.Error.Reason, _Mapping]]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    ERROR_FIELD_NUMBER: _ClassVar[int]
    data: DeleteDomainReply.Data
    error: DeleteDomainReply.Error
    def __init__(self, data: _Optional[_Union[DeleteDomainReply.Data, _Mapping]] = ..., error: _Optional[_Union[DeleteDomainReply.Error, _Mapping]] = ...) -> None: ...
