from fred_api.registry.domain import domain_common_types_pb2 as _domain_common_types_pb2
from fred_api.registry import common_types_pb2 as _common_types_pb2
from fred_api.registry import error_types_pb2 as _error_types_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class DomainHistoryRequest(_message.Message):
    __slots__ = ("domain_id", "history")
    DOMAIN_ID_FIELD_NUMBER: _ClassVar[int]
    HISTORY_FIELD_NUMBER: _ClassVar[int]
    domain_id: _domain_common_types_pb2.DomainId
    history: _domain_common_types_pb2.DomainHistoryInterval
    def __init__(self, domain_id: _Optional[_Union[_domain_common_types_pb2.DomainId, _Mapping]] = ..., history: _Optional[_Union[_domain_common_types_pb2.DomainHistoryInterval, _Mapping]] = ...) -> None: ...

class DomainHistoryRecord(_message.Message):
    __slots__ = ("domain_history_id", "valid_from", "log_entry_id")
    DOMAIN_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
    VALID_FROM_FIELD_NUMBER: _ClassVar[int]
    LOG_ENTRY_ID_FIELD_NUMBER: _ClassVar[int]
    domain_history_id: _domain_common_types_pb2.DomainHistoryId
    valid_from: _timestamp_pb2.Timestamp
    log_entry_id: _common_types_pb2.LogEntryId
    def __init__(self, domain_history_id: _Optional[_Union[_domain_common_types_pb2.DomainHistoryId, _Mapping]] = ..., valid_from: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., log_entry_id: _Optional[_Union[_common_types_pb2.LogEntryId, _Mapping]] = ...) -> None: ...

class DomainHistoryReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("domain_id", "timeline", "valid_to")
        DOMAIN_ID_FIELD_NUMBER: _ClassVar[int]
        TIMELINE_FIELD_NUMBER: _ClassVar[int]
        VALID_TO_FIELD_NUMBER: _ClassVar[int]
        domain_id: _domain_common_types_pb2.DomainId
        timeline: _containers.RepeatedCompositeFieldContainer[DomainHistoryRecord]
        valid_to: _timestamp_pb2.Timestamp
        def __init__(self, domain_id: _Optional[_Union[_domain_common_types_pb2.DomainId, _Mapping]] = ..., timeline: _Optional[_Iterable[_Union[DomainHistoryRecord, _Mapping]]] = ..., valid_to: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("domain_does_not_exist", "invalid_history_interval")
        class InvalidHistoryInterval(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        DOMAIN_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        INVALID_HISTORY_INTERVAL_FIELD_NUMBER: _ClassVar[int]
        domain_does_not_exist: _error_types_pb2.DomainDoesNotExist
        invalid_history_interval: DomainHistoryReply.Exception.InvalidHistoryInterval
        def __init__(self, domain_does_not_exist: _Optional[_Union[_error_types_pb2.DomainDoesNotExist, _Mapping]] = ..., invalid_history_interval: _Optional[_Union[DomainHistoryReply.Exception.InvalidHistoryInterval, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: DomainHistoryReply.Data
    exception: DomainHistoryReply.Exception
    def __init__(self, data: _Optional[_Union[DomainHistoryReply.Data, _Mapping]] = ..., exception: _Optional[_Union[DomainHistoryReply.Exception, _Mapping]] = ...) -> None: ...
