from fred_api.registry import common_types_pb2 as _common_types_pb2
from fred_api.registry import error_types_pb2 as _error_types_pb2
from fred_api.registry.contact import contact_common_types_pb2 as _contact_common_types_pb2
from fred_api.registry.domain import domain_common_types_pb2 as _domain_common_types_pb2
from fred_api.registry.keyset import keyset_common_types_pb2 as _keyset_common_types_pb2
from fred_api.registry.nsset import nsset_common_types_pb2 as _nsset_common_types_pb2
from fred_api.registry import object_events_pb2 as _object_events_pb2
from fred_api.registry.registrar import registrar_common_types_pb2 as _registrar_common_types_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class DomainInfoRequest(_message.Message):
    __slots__ = ("domain_id", "domain_history_id", "domain_snapshot_id")
    DOMAIN_ID_FIELD_NUMBER: _ClassVar[int]
    DOMAIN_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
    DOMAIN_SNAPSHOT_ID_FIELD_NUMBER: _ClassVar[int]
    domain_id: _domain_common_types_pb2.DomainId
    domain_history_id: _domain_common_types_pb2.DomainHistoryId
    domain_snapshot_id: _common_types_pb2.SnapshotId
    def __init__(self, domain_id: _Optional[_Union[_domain_common_types_pb2.DomainId, _Mapping]] = ..., domain_history_id: _Optional[_Union[_domain_common_types_pb2.DomainHistoryId, _Mapping]] = ..., domain_snapshot_id: _Optional[_Union[_common_types_pb2.SnapshotId, _Mapping]] = ...) -> None: ...

class DomainInfoReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("fqdn", "domain_id", "domain_history_id", "snapshot_id", "nsset_old", "nsset", "keyset_old", "keyset", "registrant_old", "registrant", "sponsoring_registrar", "administrative_contacts_old", "administrative_contacts", "expires_at", "events", "expiration_warning_scheduled_at", "outzone_unguarded_warning_scheduled_at", "outzone_scheduled_at", "delete_warning_scheduled_at", "delete_candidate_scheduled_at", "validation_expires_at", "outzone_at", "delete_candidate_at")
        FQDN_FIELD_NUMBER: _ClassVar[int]
        DOMAIN_ID_FIELD_NUMBER: _ClassVar[int]
        DOMAIN_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
        SNAPSHOT_ID_FIELD_NUMBER: _ClassVar[int]
        NSSET_OLD_FIELD_NUMBER: _ClassVar[int]
        NSSET_FIELD_NUMBER: _ClassVar[int]
        KEYSET_OLD_FIELD_NUMBER: _ClassVar[int]
        KEYSET_FIELD_NUMBER: _ClassVar[int]
        REGISTRANT_OLD_FIELD_NUMBER: _ClassVar[int]
        REGISTRANT_FIELD_NUMBER: _ClassVar[int]
        SPONSORING_REGISTRAR_FIELD_NUMBER: _ClassVar[int]
        ADMINISTRATIVE_CONTACTS_OLD_FIELD_NUMBER: _ClassVar[int]
        ADMINISTRATIVE_CONTACTS_FIELD_NUMBER: _ClassVar[int]
        EXPIRES_AT_FIELD_NUMBER: _ClassVar[int]
        EVENTS_FIELD_NUMBER: _ClassVar[int]
        EXPIRATION_WARNING_SCHEDULED_AT_FIELD_NUMBER: _ClassVar[int]
        OUTZONE_UNGUARDED_WARNING_SCHEDULED_AT_FIELD_NUMBER: _ClassVar[int]
        OUTZONE_SCHEDULED_AT_FIELD_NUMBER: _ClassVar[int]
        DELETE_WARNING_SCHEDULED_AT_FIELD_NUMBER: _ClassVar[int]
        DELETE_CANDIDATE_SCHEDULED_AT_FIELD_NUMBER: _ClassVar[int]
        VALIDATION_EXPIRES_AT_FIELD_NUMBER: _ClassVar[int]
        OUTZONE_AT_FIELD_NUMBER: _ClassVar[int]
        DELETE_CANDIDATE_AT_FIELD_NUMBER: _ClassVar[int]
        fqdn: _domain_common_types_pb2.Fqdn
        domain_id: _domain_common_types_pb2.DomainId
        domain_history_id: _domain_common_types_pb2.DomainHistoryId
        snapshot_id: _common_types_pb2.SnapshotId
        nsset_old: _nsset_common_types_pb2.NssetId
        nsset: _nsset_common_types_pb2.NssetRef
        keyset_old: _keyset_common_types_pb2.KeysetId
        keyset: _keyset_common_types_pb2.KeysetRef
        registrant_old: _contact_common_types_pb2.ContactId
        registrant: _contact_common_types_pb2.ContactRef
        sponsoring_registrar: _registrar_common_types_pb2.RegistrarHandle
        administrative_contacts_old: _containers.RepeatedCompositeFieldContainer[_contact_common_types_pb2.ContactId]
        administrative_contacts: _containers.RepeatedCompositeFieldContainer[_contact_common_types_pb2.ContactRef]
        expires_at: _timestamp_pb2.Timestamp
        events: _object_events_pb2.ObjectEvents
        expiration_warning_scheduled_at: _timestamp_pb2.Timestamp
        outzone_unguarded_warning_scheduled_at: _timestamp_pb2.Timestamp
        outzone_scheduled_at: _timestamp_pb2.Timestamp
        delete_warning_scheduled_at: _timestamp_pb2.Timestamp
        delete_candidate_scheduled_at: _timestamp_pb2.Timestamp
        validation_expires_at: _timestamp_pb2.Timestamp
        outzone_at: _timestamp_pb2.Timestamp
        delete_candidate_at: _timestamp_pb2.Timestamp
        def __init__(self, fqdn: _Optional[_Union[_domain_common_types_pb2.Fqdn, _Mapping]] = ..., domain_id: _Optional[_Union[_domain_common_types_pb2.DomainId, _Mapping]] = ..., domain_history_id: _Optional[_Union[_domain_common_types_pb2.DomainHistoryId, _Mapping]] = ..., snapshot_id: _Optional[_Union[_common_types_pb2.SnapshotId, _Mapping]] = ..., nsset_old: _Optional[_Union[_nsset_common_types_pb2.NssetId, _Mapping]] = ..., nsset: _Optional[_Union[_nsset_common_types_pb2.NssetRef, _Mapping]] = ..., keyset_old: _Optional[_Union[_keyset_common_types_pb2.KeysetId, _Mapping]] = ..., keyset: _Optional[_Union[_keyset_common_types_pb2.KeysetRef, _Mapping]] = ..., registrant_old: _Optional[_Union[_contact_common_types_pb2.ContactId, _Mapping]] = ..., registrant: _Optional[_Union[_contact_common_types_pb2.ContactRef, _Mapping]] = ..., sponsoring_registrar: _Optional[_Union[_registrar_common_types_pb2.RegistrarHandle, _Mapping]] = ..., administrative_contacts_old: _Optional[_Iterable[_Union[_contact_common_types_pb2.ContactId, _Mapping]]] = ..., administrative_contacts: _Optional[_Iterable[_Union[_contact_common_types_pb2.ContactRef, _Mapping]]] = ..., expires_at: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., events: _Optional[_Union[_object_events_pb2.ObjectEvents, _Mapping]] = ..., expiration_warning_scheduled_at: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., outzone_unguarded_warning_scheduled_at: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., outzone_scheduled_at: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., delete_warning_scheduled_at: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., delete_candidate_scheduled_at: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., validation_expires_at: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., outzone_at: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., delete_candidate_at: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("domain_does_not_exist", "invalid_data", "invalid_snapshot")
        DOMAIN_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        INVALID_DATA_FIELD_NUMBER: _ClassVar[int]
        INVALID_SNAPSHOT_FIELD_NUMBER: _ClassVar[int]
        domain_does_not_exist: _error_types_pb2.DomainDoesNotExist
        invalid_data: _error_types_pb2.InvalidData
        invalid_snapshot: _error_types_pb2.InvalidSnapshot
        def __init__(self, domain_does_not_exist: _Optional[_Union[_error_types_pb2.DomainDoesNotExist, _Mapping]] = ..., invalid_data: _Optional[_Union[_error_types_pb2.InvalidData, _Mapping]] = ..., invalid_snapshot: _Optional[_Union[_error_types_pb2.InvalidSnapshot, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: DomainInfoReply.Data
    exception: DomainInfoReply.Exception
    def __init__(self, data: _Optional[_Union[DomainInfoReply.Data, _Mapping]] = ..., exception: _Optional[_Union[DomainInfoReply.Exception, _Mapping]] = ...) -> None: ...

class BatchDomainInfoRequest(_message.Message):
    __slots__ = ("requests",)
    REQUESTS_FIELD_NUMBER: _ClassVar[int]
    requests: _containers.RepeatedCompositeFieldContainer[DomainInfoRequest]
    def __init__(self, requests: _Optional[_Iterable[_Union[DomainInfoRequest, _Mapping]]] = ...) -> None: ...

class BatchDomainInfoReply(_message.Message):
    __slots__ = ("data",)
    class Data(_message.Message):
        __slots__ = ("replies",)
        class BatchReply(_message.Message):
            __slots__ = ("data", "error")
            DATA_FIELD_NUMBER: _ClassVar[int]
            ERROR_FIELD_NUMBER: _ClassVar[int]
            data: DomainInfoReply.Data
            error: BatchDomainInfoReply.Error
            def __init__(self, data: _Optional[_Union[DomainInfoReply.Data, _Mapping]] = ..., error: _Optional[_Union[BatchDomainInfoReply.Error, _Mapping]] = ...) -> None: ...
        REPLIES_FIELD_NUMBER: _ClassVar[int]
        replies: _containers.RepeatedCompositeFieldContainer[BatchDomainInfoReply.Data.BatchReply]
        def __init__(self, replies: _Optional[_Iterable[_Union[BatchDomainInfoReply.Data.BatchReply, _Mapping]]] = ...) -> None: ...
    class Error(_message.Message):
        __slots__ = ("request", "exception")
        REQUEST_FIELD_NUMBER: _ClassVar[int]
        EXCEPTION_FIELD_NUMBER: _ClassVar[int]
        request: DomainInfoRequest
        exception: DomainInfoReply.Exception
        def __init__(self, request: _Optional[_Union[DomainInfoRequest, _Mapping]] = ..., exception: _Optional[_Union[DomainInfoReply.Exception, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    data: BatchDomainInfoReply.Data
    def __init__(self, data: _Optional[_Union[BatchDomainInfoReply.Data, _Mapping]] = ...) -> None: ...

class DomainIdRequest(_message.Message):
    __slots__ = ("fqdn",)
    FQDN_FIELD_NUMBER: _ClassVar[int]
    fqdn: _domain_common_types_pb2.Fqdn
    def __init__(self, fqdn: _Optional[_Union[_domain_common_types_pb2.Fqdn, _Mapping]] = ...) -> None: ...

class DomainIdReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("domain_id", "domain_history_id")
        DOMAIN_ID_FIELD_NUMBER: _ClassVar[int]
        DOMAIN_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
        domain_id: _domain_common_types_pb2.DomainId
        domain_history_id: _domain_common_types_pb2.DomainHistoryId
        def __init__(self, domain_id: _Optional[_Union[_domain_common_types_pb2.DomainId, _Mapping]] = ..., domain_history_id: _Optional[_Union[_domain_common_types_pb2.DomainHistoryId, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("domain_does_not_exist",)
        DOMAIN_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        domain_does_not_exist: _error_types_pb2.DomainDoesNotExist
        def __init__(self, domain_does_not_exist: _Optional[_Union[_error_types_pb2.DomainDoesNotExist, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: DomainIdReply.Data
    exception: DomainIdReply.Exception
    def __init__(self, data: _Optional[_Union[DomainIdReply.Data, _Mapping]] = ..., exception: _Optional[_Union[DomainIdReply.Exception, _Mapping]] = ...) -> None: ...
