from fred_api.registry import error_types_pb2 as _error_types_pb2
from fred_api.registry.domain import domain_common_types_pb2 as _domain_common_types_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class DomainStateHistoryRequest(_message.Message):
    __slots__ = ("domain_id", "history")
    DOMAIN_ID_FIELD_NUMBER: _ClassVar[int]
    HISTORY_FIELD_NUMBER: _ClassVar[int]
    domain_id: _domain_common_types_pb2.DomainId
    history: _domain_common_types_pb2.DomainHistoryInterval
    def __init__(self, domain_id: _Optional[_Union[_domain_common_types_pb2.DomainId, _Mapping]] = ..., history: _Optional[_Union[_domain_common_types_pb2.DomainHistoryInterval, _Mapping]] = ...) -> None: ...

class DomainStateHistory(_message.Message):
    __slots__ = ("timeline", "valid_to")
    class Record(_message.Message):
        __slots__ = ("valid_from", "flags")
        class FlagsEntry(_message.Message):
            __slots__ = ("key", "value")
            KEY_FIELD_NUMBER: _ClassVar[int]
            VALUE_FIELD_NUMBER: _ClassVar[int]
            key: str
            value: bool
            def __init__(self, key: _Optional[str] = ..., value: bool = ...) -> None: ...
        VALID_FROM_FIELD_NUMBER: _ClassVar[int]
        FLAGS_FIELD_NUMBER: _ClassVar[int]
        valid_from: _timestamp_pb2.Timestamp
        flags: _containers.ScalarMap[str, bool]
        def __init__(self, valid_from: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., flags: _Optional[_Mapping[str, bool]] = ...) -> None: ...
    TIMELINE_FIELD_NUMBER: _ClassVar[int]
    VALID_TO_FIELD_NUMBER: _ClassVar[int]
    timeline: _containers.RepeatedCompositeFieldContainer[DomainStateHistory.Record]
    valid_to: _timestamp_pb2.Timestamp
    def __init__(self, timeline: _Optional[_Iterable[_Union[DomainStateHistory.Record, _Mapping]]] = ..., valid_to: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...

class DomainStateHistoryReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("domain_id", "history")
        DOMAIN_ID_FIELD_NUMBER: _ClassVar[int]
        HISTORY_FIELD_NUMBER: _ClassVar[int]
        domain_id: _domain_common_types_pb2.DomainId
        history: DomainStateHistory
        def __init__(self, domain_id: _Optional[_Union[_domain_common_types_pb2.DomainId, _Mapping]] = ..., history: _Optional[_Union[DomainStateHistory, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("domain_does_not_exist", "invalid_history_interval")
        class InvalidHistoryInterval(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        DOMAIN_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        INVALID_HISTORY_INTERVAL_FIELD_NUMBER: _ClassVar[int]
        domain_does_not_exist: _error_types_pb2.DomainDoesNotExist
        invalid_history_interval: DomainStateHistoryReply.Exception.InvalidHistoryInterval
        def __init__(self, domain_does_not_exist: _Optional[_Union[_error_types_pb2.DomainDoesNotExist, _Mapping]] = ..., invalid_history_interval: _Optional[_Union[DomainStateHistoryReply.Exception.InvalidHistoryInterval, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: DomainStateHistoryReply.Data
    exception: DomainStateHistoryReply.Exception
    def __init__(self, data: _Optional[_Union[DomainStateHistoryReply.Data, _Mapping]] = ..., exception: _Optional[_Union[DomainStateHistoryReply.Exception, _Mapping]] = ...) -> None: ...
