from fred_api.registry import pagination_pb2 as _pagination_pb2
from fred_api.registry.contact import contact_common_types_pb2 as _contact_common_types_pb2
from fred_api.registry.domain import domain_common_types_pb2 as _domain_common_types_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class BatchDeleteDomainsRequest(_message.Message):
    __slots__ = ("domains",)
    class Domain(_message.Message):
        __slots__ = ("domain_id", "domain_history_id")
        DOMAIN_ID_FIELD_NUMBER: _ClassVar[int]
        DOMAIN_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
        domain_id: _domain_common_types_pb2.DomainId
        domain_history_id: _domain_common_types_pb2.DomainHistoryId
        def __init__(self, domain_id: _Optional[_Union[_domain_common_types_pb2.DomainId, _Mapping]] = ..., domain_history_id: _Optional[_Union[_domain_common_types_pb2.DomainHistoryId, _Mapping]] = ...) -> None: ...
    DOMAINS_FIELD_NUMBER: _ClassVar[int]
    domains: _containers.RepeatedCompositeFieldContainer[BatchDeleteDomainsRequest.Domain]
    def __init__(self, domains: _Optional[_Iterable[_Union[BatchDeleteDomainsRequest.Domain, _Mapping]]] = ...) -> None: ...

class BatchDeleteDomainsReply(_message.Message):
    __slots__ = ("data",)
    class Data(_message.Message):
        __slots__ = ("not_deleted_domains",)
        NOT_DELETED_DOMAINS_FIELD_NUMBER: _ClassVar[int]
        not_deleted_domains: _containers.RepeatedCompositeFieldContainer[BatchDeleteDomainsReply.NotDeleted]
        def __init__(self, not_deleted_domains: _Optional[_Iterable[_Union[BatchDeleteDomainsReply.NotDeleted, _Mapping]]] = ...) -> None: ...
    class NotDeleted(_message.Message):
        __slots__ = ("domain_id", "reason")
        class Reason(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
            __slots__ = ()
            undefined: _ClassVar[BatchDeleteDomainsReply.NotDeleted.Reason]
            domain_blocked: _ClassVar[BatchDeleteDomainsReply.NotDeleted.Reason]
            domain_does_not_exist: _ClassVar[BatchDeleteDomainsReply.NotDeleted.Reason]
            domain_history_id_mismatch: _ClassVar[BatchDeleteDomainsReply.NotDeleted.Reason]
            insufficient_permissions: _ClassVar[BatchDeleteDomainsReply.NotDeleted.Reason]
        undefined: BatchDeleteDomainsReply.NotDeleted.Reason
        domain_blocked: BatchDeleteDomainsReply.NotDeleted.Reason
        domain_does_not_exist: BatchDeleteDomainsReply.NotDeleted.Reason
        domain_history_id_mismatch: BatchDeleteDomainsReply.NotDeleted.Reason
        insufficient_permissions: BatchDeleteDomainsReply.NotDeleted.Reason
        DOMAIN_ID_FIELD_NUMBER: _ClassVar[int]
        REASON_FIELD_NUMBER: _ClassVar[int]
        domain_id: _domain_common_types_pb2.DomainId
        reason: BatchDeleteDomainsReply.NotDeleted.Reason
        def __init__(self, domain_id: _Optional[_Union[_domain_common_types_pb2.DomainId, _Mapping]] = ..., reason: _Optional[_Union[BatchDeleteDomainsReply.NotDeleted.Reason, str]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    data: BatchDeleteDomainsReply.Data
    def __init__(self, data: _Optional[_Union[BatchDeleteDomainsReply.Data, _Mapping]] = ...) -> None: ...

class ManageDomainStateFlagsRequest(_message.Message):
    __slots__ = ("state_flag_requests_to_create", "state_flag_requests_to_close")
    class Domain(_message.Message):
        __slots__ = ("domain_id", "domain_history_id")
        DOMAIN_ID_FIELD_NUMBER: _ClassVar[int]
        DOMAIN_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
        domain_id: _domain_common_types_pb2.DomainId
        domain_history_id: _domain_common_types_pb2.DomainHistoryId
        def __init__(self, domain_id: _Optional[_Union[_domain_common_types_pb2.DomainId, _Mapping]] = ..., domain_history_id: _Optional[_Union[_domain_common_types_pb2.DomainHistoryId, _Mapping]] = ...) -> None: ...
    class Validity(_message.Message):
        __slots__ = ("valid_from", "valid_to")
        VALID_FROM_FIELD_NUMBER: _ClassVar[int]
        VALID_TO_FIELD_NUMBER: _ClassVar[int]
        valid_from: _timestamp_pb2.Timestamp
        valid_to: _timestamp_pb2.Timestamp
        def __init__(self, valid_from: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., valid_to: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...
    class ToCreate(_message.Message):
        __slots__ = ("state_flags", "domains")
        class StateFlagsEntry(_message.Message):
            __slots__ = ("key", "value")
            KEY_FIELD_NUMBER: _ClassVar[int]
            VALUE_FIELD_NUMBER: _ClassVar[int]
            key: str
            value: ManageDomainStateFlagsRequest.Validity
            def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[ManageDomainStateFlagsRequest.Validity, _Mapping]] = ...) -> None: ...
        STATE_FLAGS_FIELD_NUMBER: _ClassVar[int]
        DOMAINS_FIELD_NUMBER: _ClassVar[int]
        state_flags: _containers.MessageMap[str, ManageDomainStateFlagsRequest.Validity]
        domains: _containers.RepeatedCompositeFieldContainer[ManageDomainStateFlagsRequest.Domain]
        def __init__(self, state_flags: _Optional[_Mapping[str, ManageDomainStateFlagsRequest.Validity]] = ..., domains: _Optional[_Iterable[_Union[ManageDomainStateFlagsRequest.Domain, _Mapping]]] = ...) -> None: ...
    STATE_FLAG_REQUESTS_TO_CREATE_FIELD_NUMBER: _ClassVar[int]
    STATE_FLAG_REQUESTS_TO_CLOSE_FIELD_NUMBER: _ClassVar[int]
    state_flag_requests_to_create: ManageDomainStateFlagsRequest.ToCreate
    state_flag_requests_to_close: _containers.RepeatedCompositeFieldContainer[_domain_common_types_pb2.DomainStateFlagRequest]
    def __init__(self, state_flag_requests_to_create: _Optional[_Union[ManageDomainStateFlagsRequest.ToCreate, _Mapping]] = ..., state_flag_requests_to_close: _Optional[_Iterable[_Union[_domain_common_types_pb2.DomainStateFlagRequest, _Mapping]]] = ...) -> None: ...

class ManageDomainStateFlagsReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("state_flag_requests_created",)
        class DomainStateFlagRequestInfo(_message.Message):
            __slots__ = ("request_id", "domain_id", "state_flag")
            REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
            DOMAIN_ID_FIELD_NUMBER: _ClassVar[int]
            STATE_FLAG_FIELD_NUMBER: _ClassVar[int]
            request_id: _domain_common_types_pb2.DomainStateFlagRequest
            domain_id: _domain_common_types_pb2.DomainId
            state_flag: str
            def __init__(self, request_id: _Optional[_Union[_domain_common_types_pb2.DomainStateFlagRequest, _Mapping]] = ..., domain_id: _Optional[_Union[_domain_common_types_pb2.DomainId, _Mapping]] = ..., state_flag: _Optional[str] = ...) -> None: ...
        STATE_FLAG_REQUESTS_CREATED_FIELD_NUMBER: _ClassVar[int]
        state_flag_requests_created: _containers.RepeatedCompositeFieldContainer[ManageDomainStateFlagsReply.Data.DomainStateFlagRequestInfo]
        def __init__(self, state_flag_requests_created: _Optional[_Iterable[_Union[ManageDomainStateFlagsReply.Data.DomainStateFlagRequestInfo, _Mapping]]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("domain_does_not_exist", "request_does_not_exist", "state_flag_does_not_exist", "domain_history_id_mismatch")
        class DomainDoesNotExist(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        class DomainStateFlagRequestDoesNotExist(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        class DomainStateFlagDoesNotExist(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        class DomainHistoryIdMismatch(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        DOMAIN_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        REQUEST_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        STATE_FLAG_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        DOMAIN_HISTORY_ID_MISMATCH_FIELD_NUMBER: _ClassVar[int]
        domain_does_not_exist: ManageDomainStateFlagsReply.Exception.DomainDoesNotExist
        request_does_not_exist: ManageDomainStateFlagsReply.Exception.DomainStateFlagRequestDoesNotExist
        state_flag_does_not_exist: ManageDomainStateFlagsReply.Exception.DomainStateFlagDoesNotExist
        domain_history_id_mismatch: ManageDomainStateFlagsReply.Exception.DomainHistoryIdMismatch
        def __init__(self, domain_does_not_exist: _Optional[_Union[ManageDomainStateFlagsReply.Exception.DomainDoesNotExist, _Mapping]] = ..., request_does_not_exist: _Optional[_Union[ManageDomainStateFlagsReply.Exception.DomainStateFlagRequestDoesNotExist, _Mapping]] = ..., state_flag_does_not_exist: _Optional[_Union[ManageDomainStateFlagsReply.Exception.DomainStateFlagDoesNotExist, _Mapping]] = ..., domain_history_id_mismatch: _Optional[_Union[ManageDomainStateFlagsReply.Exception.DomainHistoryIdMismatch, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: ManageDomainStateFlagsReply.Data
    exception: ManageDomainStateFlagsReply.Exception
    def __init__(self, data: _Optional[_Union[ManageDomainStateFlagsReply.Data, _Mapping]] = ..., exception: _Optional[_Union[ManageDomainStateFlagsReply.Exception, _Mapping]] = ...) -> None: ...

class DomainContactInfo(_message.Message):
    __slots__ = ("email", "telephone")
    EMAIL_FIELD_NUMBER: _ClassVar[int]
    TELEPHONE_FIELD_NUMBER: _ClassVar[int]
    email: str
    telephone: str
    def __init__(self, email: _Optional[str] = ..., telephone: _Optional[str] = ...) -> None: ...

class GetDomainsOutzoneNotifyInfoRequest(_message.Message):
    __slots__ = ("outzone_from", "outzone_to", "pagination")
    OUTZONE_FROM_FIELD_NUMBER: _ClassVar[int]
    OUTZONE_TO_FIELD_NUMBER: _ClassVar[int]
    PAGINATION_FIELD_NUMBER: _ClassVar[int]
    outzone_from: _timestamp_pb2.Timestamp
    outzone_to: _timestamp_pb2.Timestamp
    pagination: _pagination_pb2.PaginationRequest
    def __init__(self, outzone_from: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., outzone_to: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., pagination: _Optional[_Union[_pagination_pb2.PaginationRequest, _Mapping]] = ...) -> None: ...

class GetDomainsDeleteNotifyInfoRequest(_message.Message):
    __slots__ = ("delete_from", "delete_to", "pagination")
    DELETE_FROM_FIELD_NUMBER: _ClassVar[int]
    DELETE_TO_FIELD_NUMBER: _ClassVar[int]
    PAGINATION_FIELD_NUMBER: _ClassVar[int]
    delete_from: _timestamp_pb2.Timestamp
    delete_to: _timestamp_pb2.Timestamp
    pagination: _pagination_pb2.PaginationRequest
    def __init__(self, delete_from: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., delete_to: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., pagination: _Optional[_Union[_pagination_pb2.PaginationRequest, _Mapping]] = ...) -> None: ...

class GetDomainsNotifyInfoReply(_message.Message):
    __slots__ = ("data",)
    class Data(_message.Message):
        __slots__ = ("domains", "pagination")
        class Info(_message.Message):
            __slots__ = ("domain_id", "fqdn", "registrant_id", "registrant_handle", "registrant_name", "registrant_organization", "contacts", "additional_contacts")
            DOMAIN_ID_FIELD_NUMBER: _ClassVar[int]
            FQDN_FIELD_NUMBER: _ClassVar[int]
            REGISTRANT_ID_FIELD_NUMBER: _ClassVar[int]
            REGISTRANT_HANDLE_FIELD_NUMBER: _ClassVar[int]
            REGISTRANT_NAME_FIELD_NUMBER: _ClassVar[int]
            REGISTRANT_ORGANIZATION_FIELD_NUMBER: _ClassVar[int]
            CONTACTS_FIELD_NUMBER: _ClassVar[int]
            ADDITIONAL_CONTACTS_FIELD_NUMBER: _ClassVar[int]
            domain_id: _domain_common_types_pb2.DomainId
            fqdn: str
            registrant_id: _contact_common_types_pb2.ContactId
            registrant_handle: _contact_common_types_pb2.ContactHandle
            registrant_name: str
            registrant_organization: str
            contacts: _containers.RepeatedCompositeFieldContainer[DomainContactInfo]
            additional_contacts: _containers.RepeatedCompositeFieldContainer[DomainContactInfo]
            def __init__(self, domain_id: _Optional[_Union[_domain_common_types_pb2.DomainId, _Mapping]] = ..., fqdn: _Optional[str] = ..., registrant_id: _Optional[_Union[_contact_common_types_pb2.ContactId, _Mapping]] = ..., registrant_handle: _Optional[_Union[_contact_common_types_pb2.ContactHandle, _Mapping]] = ..., registrant_name: _Optional[str] = ..., registrant_organization: _Optional[str] = ..., contacts: _Optional[_Iterable[_Union[DomainContactInfo, _Mapping]]] = ..., additional_contacts: _Optional[_Iterable[_Union[DomainContactInfo, _Mapping]]] = ...) -> None: ...
        DOMAINS_FIELD_NUMBER: _ClassVar[int]
        PAGINATION_FIELD_NUMBER: _ClassVar[int]
        domains: _containers.RepeatedCompositeFieldContainer[GetDomainsNotifyInfoReply.Data.Info]
        pagination: _pagination_pb2.PaginationReply
        def __init__(self, domains: _Optional[_Iterable[_Union[GetDomainsNotifyInfoReply.Data.Info, _Mapping]]] = ..., pagination: _Optional[_Union[_pagination_pb2.PaginationReply, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    data: GetDomainsNotifyInfoReply.Data
    def __init__(self, data: _Optional[_Union[GetDomainsNotifyInfoReply.Data, _Mapping]] = ...) -> None: ...

class UpdateDomainsOutzoneAdditionalNotifyInfoRequest(_message.Message):
    __slots__ = ("domains_additional_info",)
    class DomainAdditionalInfo(_message.Message):
        __slots__ = ("domain_id", "outzone_from", "outzone_to", "additional_contacts")
        DOMAIN_ID_FIELD_NUMBER: _ClassVar[int]
        OUTZONE_FROM_FIELD_NUMBER: _ClassVar[int]
        OUTZONE_TO_FIELD_NUMBER: _ClassVar[int]
        ADDITIONAL_CONTACTS_FIELD_NUMBER: _ClassVar[int]
        domain_id: _domain_common_types_pb2.DomainId
        outzone_from: _timestamp_pb2.Timestamp
        outzone_to: _timestamp_pb2.Timestamp
        additional_contacts: _containers.RepeatedCompositeFieldContainer[DomainContactInfo]
        def __init__(self, domain_id: _Optional[_Union[_domain_common_types_pb2.DomainId, _Mapping]] = ..., outzone_from: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., outzone_to: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., additional_contacts: _Optional[_Iterable[_Union[DomainContactInfo, _Mapping]]] = ...) -> None: ...
    DOMAINS_ADDITIONAL_INFO_FIELD_NUMBER: _ClassVar[int]
    domains_additional_info: _containers.RepeatedCompositeFieldContainer[UpdateDomainsOutzoneAdditionalNotifyInfoRequest.DomainAdditionalInfo]
    def __init__(self, domains_additional_info: _Optional[_Iterable[_Union[UpdateDomainsOutzoneAdditionalNotifyInfoRequest.DomainAdditionalInfo, _Mapping]]] = ...) -> None: ...

class UpdateDomainsDeleteAdditionalNotifyInfoRequest(_message.Message):
    __slots__ = ("domains_additional_info",)
    class DomainAdditionalInfo(_message.Message):
        __slots__ = ("domain_id", "delete_from", "delete_to", "additional_contacts")
        DOMAIN_ID_FIELD_NUMBER: _ClassVar[int]
        DELETE_FROM_FIELD_NUMBER: _ClassVar[int]
        DELETE_TO_FIELD_NUMBER: _ClassVar[int]
        ADDITIONAL_CONTACTS_FIELD_NUMBER: _ClassVar[int]
        domain_id: _domain_common_types_pb2.DomainId
        delete_from: _timestamp_pb2.Timestamp
        delete_to: _timestamp_pb2.Timestamp
        additional_contacts: _containers.RepeatedCompositeFieldContainer[DomainContactInfo]
        def __init__(self, domain_id: _Optional[_Union[_domain_common_types_pb2.DomainId, _Mapping]] = ..., delete_from: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., delete_to: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., additional_contacts: _Optional[_Iterable[_Union[DomainContactInfo, _Mapping]]] = ...) -> None: ...
    DOMAINS_ADDITIONAL_INFO_FIELD_NUMBER: _ClassVar[int]
    domains_additional_info: _containers.RepeatedCompositeFieldContainer[UpdateDomainsDeleteAdditionalNotifyInfoRequest.DomainAdditionalInfo]
    def __init__(self, domains_additional_info: _Optional[_Iterable[_Union[UpdateDomainsDeleteAdditionalNotifyInfoRequest.DomainAdditionalInfo, _Mapping]]] = ...) -> None: ...

class UpdateDomainsAdditionalNotifyInfoReply(_message.Message):
    __slots__ = ("exception",)
    class Exception(_message.Message):
        __slots__ = ("domain_does_not_exist", "invalid_domain_contact_info")
        class DomainDoesNotExist(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        class InvalidDomainContactInfo(_message.Message):
            __slots__ = ("invalid_value",)
            INVALID_VALUE_FIELD_NUMBER: _ClassVar[int]
            invalid_value: str
            def __init__(self, invalid_value: _Optional[str] = ...) -> None: ...
        DOMAIN_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        INVALID_DOMAIN_CONTACT_INFO_FIELD_NUMBER: _ClassVar[int]
        domain_does_not_exist: UpdateDomainsAdditionalNotifyInfoReply.Exception.DomainDoesNotExist
        invalid_domain_contact_info: UpdateDomainsAdditionalNotifyInfoReply.Exception.InvalidDomainContactInfo
        def __init__(self, domain_does_not_exist: _Optional[_Union[UpdateDomainsAdditionalNotifyInfoReply.Exception.DomainDoesNotExist, _Mapping]] = ..., invalid_domain_contact_info: _Optional[_Union[UpdateDomainsAdditionalNotifyInfoReply.Exception.InvalidDomainContactInfo, _Mapping]] = ...) -> None: ...
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    exception: UpdateDomainsAdditionalNotifyInfoReply.Exception
    def __init__(self, exception: _Optional[_Union[UpdateDomainsAdditionalNotifyInfoReply.Exception, _Mapping]] = ...) -> None: ...
