from fred_api.registry.domain import domain_common_types_pb2 as _domain_common_types_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class SearchDomainRequest(_message.Message):
    __slots__ = ("query_values", "limit", "searched_items")
    QUERY_VALUES_FIELD_NUMBER: _ClassVar[int]
    LIMIT_FIELD_NUMBER: _ClassVar[int]
    SEARCHED_ITEMS_FIELD_NUMBER: _ClassVar[int]
    query_values: _containers.RepeatedScalarFieldContainer[str]
    limit: int
    searched_items: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, query_values: _Optional[_Iterable[str]] = ..., limit: _Optional[int] = ..., searched_items: _Optional[_Iterable[str]] = ...) -> None: ...

class SearchDomainHistoryRequest(_message.Message):
    __slots__ = ("query_values", "max_number_of_domains", "data_valid_from", "data_valid_to", "searched_items")
    QUERY_VALUES_FIELD_NUMBER: _ClassVar[int]
    MAX_NUMBER_OF_DOMAINS_FIELD_NUMBER: _ClassVar[int]
    DATA_VALID_FROM_FIELD_NUMBER: _ClassVar[int]
    DATA_VALID_TO_FIELD_NUMBER: _ClassVar[int]
    SEARCHED_ITEMS_FIELD_NUMBER: _ClassVar[int]
    query_values: _containers.RepeatedScalarFieldContainer[str]
    max_number_of_domains: int
    data_valid_from: _timestamp_pb2.Timestamp
    data_valid_to: _timestamp_pb2.Timestamp
    searched_items: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, query_values: _Optional[_Iterable[str]] = ..., max_number_of_domains: _Optional[int] = ..., data_valid_from: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., data_valid_to: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., searched_items: _Optional[_Iterable[str]] = ...) -> None: ...

class SearchDomainReply(_message.Message):
    __slots__ = ("data",)
    class Data(_message.Message):
        __slots__ = ("results", "estimated_total", "searched_items")
        class Result(_message.Message):
            __slots__ = ("object_id", "matched_items")
            OBJECT_ID_FIELD_NUMBER: _ClassVar[int]
            MATCHED_ITEMS_FIELD_NUMBER: _ClassVar[int]
            object_id: _domain_common_types_pb2.DomainId
            matched_items: _containers.RepeatedScalarFieldContainer[str]
            def __init__(self, object_id: _Optional[_Union[_domain_common_types_pb2.DomainId, _Mapping]] = ..., matched_items: _Optional[_Iterable[str]] = ...) -> None: ...
        class FuzzyValue(_message.Message):
            __slots__ = ("lower_estimate", "upper_estimate")
            LOWER_ESTIMATE_FIELD_NUMBER: _ClassVar[int]
            UPPER_ESTIMATE_FIELD_NUMBER: _ClassVar[int]
            lower_estimate: int
            upper_estimate: int
            def __init__(self, lower_estimate: _Optional[int] = ..., upper_estimate: _Optional[int] = ...) -> None: ...
        RESULTS_FIELD_NUMBER: _ClassVar[int]
        ESTIMATED_TOTAL_FIELD_NUMBER: _ClassVar[int]
        SEARCHED_ITEMS_FIELD_NUMBER: _ClassVar[int]
        results: _containers.RepeatedCompositeFieldContainer[SearchDomainReply.Data.Result]
        estimated_total: SearchDomainReply.Data.FuzzyValue
        searched_items: _containers.RepeatedScalarFieldContainer[str]
        def __init__(self, results: _Optional[_Iterable[_Union[SearchDomainReply.Data.Result, _Mapping]]] = ..., estimated_total: _Optional[_Union[SearchDomainReply.Data.FuzzyValue, _Mapping]] = ..., searched_items: _Optional[_Iterable[str]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    data: SearchDomainReply.Data
    def __init__(self, data: _Optional[_Union[SearchDomainReply.Data, _Mapping]] = ...) -> None: ...

class SearchDomainHistoryReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("results", "estimated_total", "searched_items")
        class Result(_message.Message):
            __slots__ = ("object_id", "histories")
            class HistoryPeriod(_message.Message):
                __slots__ = ("matched_items", "valid_from", "valid_to", "domain_history_ids")
                MATCHED_ITEMS_FIELD_NUMBER: _ClassVar[int]
                VALID_FROM_FIELD_NUMBER: _ClassVar[int]
                VALID_TO_FIELD_NUMBER: _ClassVar[int]
                DOMAIN_HISTORY_IDS_FIELD_NUMBER: _ClassVar[int]
                matched_items: _containers.RepeatedScalarFieldContainer[str]
                valid_from: _timestamp_pb2.Timestamp
                valid_to: _timestamp_pb2.Timestamp
                domain_history_ids: _containers.RepeatedCompositeFieldContainer[_domain_common_types_pb2.DomainHistoryId]
                def __init__(self, matched_items: _Optional[_Iterable[str]] = ..., valid_from: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., valid_to: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., domain_history_ids: _Optional[_Iterable[_Union[_domain_common_types_pb2.DomainHistoryId, _Mapping]]] = ...) -> None: ...
            OBJECT_ID_FIELD_NUMBER: _ClassVar[int]
            HISTORIES_FIELD_NUMBER: _ClassVar[int]
            object_id: _domain_common_types_pb2.DomainId
            histories: _containers.RepeatedCompositeFieldContainer[SearchDomainHistoryReply.Data.Result.HistoryPeriod]
            def __init__(self, object_id: _Optional[_Union[_domain_common_types_pb2.DomainId, _Mapping]] = ..., histories: _Optional[_Iterable[_Union[SearchDomainHistoryReply.Data.Result.HistoryPeriod, _Mapping]]] = ...) -> None: ...
        class FuzzyValue(_message.Message):
            __slots__ = ("lower_estimate", "upper_estimate")
            LOWER_ESTIMATE_FIELD_NUMBER: _ClassVar[int]
            UPPER_ESTIMATE_FIELD_NUMBER: _ClassVar[int]
            lower_estimate: int
            upper_estimate: int
            def __init__(self, lower_estimate: _Optional[int] = ..., upper_estimate: _Optional[int] = ...) -> None: ...
        RESULTS_FIELD_NUMBER: _ClassVar[int]
        ESTIMATED_TOTAL_FIELD_NUMBER: _ClassVar[int]
        SEARCHED_ITEMS_FIELD_NUMBER: _ClassVar[int]
        results: _containers.RepeatedCompositeFieldContainer[SearchDomainHistoryReply.Data.Result]
        estimated_total: SearchDomainHistoryReply.Data.FuzzyValue
        searched_items: _containers.RepeatedScalarFieldContainer[str]
        def __init__(self, results: _Optional[_Iterable[_Union[SearchDomainHistoryReply.Data.Result, _Mapping]]] = ..., estimated_total: _Optional[_Union[SearchDomainHistoryReply.Data.FuzzyValue, _Mapping]] = ..., searched_items: _Optional[_Iterable[str]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("chronology_violation",)
        class ChronologyViolation(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        CHRONOLOGY_VIOLATION_FIELD_NUMBER: _ClassVar[int]
        chronology_violation: SearchDomainHistoryReply.Exception.ChronologyViolation
        def __init__(self, chronology_violation: _Optional[_Union[SearchDomainHistoryReply.Exception.ChronologyViolation, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: SearchDomainHistoryReply.Data
    exception: SearchDomainHistoryReply.Exception
    def __init__(self, data: _Optional[_Union[SearchDomainHistoryReply.Data, _Mapping]] = ..., exception: _Optional[_Union[SearchDomainHistoryReply.Exception, _Mapping]] = ...) -> None: ...
