from fred_api.registry import common_types_pb2 as _common_types_pb2
from fred_api.registry import error_types_pb2 as _error_types_pb2
from fred_api.registry.domain import domain_common_types_pb2 as _domain_common_types_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class UpdateDomainStateRequest(_message.Message):
    __slots__ = ("updates", "domain_snapshot_id", "log_entry_id")
    class StateUpdate(_message.Message):
        __slots__ = ("domain_id", "set_flags", "unset_flags")
        DOMAIN_ID_FIELD_NUMBER: _ClassVar[int]
        SET_FLAGS_FIELD_NUMBER: _ClassVar[int]
        UNSET_FLAGS_FIELD_NUMBER: _ClassVar[int]
        domain_id: _domain_common_types_pb2.DomainId
        set_flags: _containers.RepeatedScalarFieldContainer[str]
        unset_flags: _containers.RepeatedScalarFieldContainer[str]
        def __init__(self, domain_id: _Optional[_Union[_domain_common_types_pb2.DomainId, _Mapping]] = ..., set_flags: _Optional[_Iterable[str]] = ..., unset_flags: _Optional[_Iterable[str]] = ...) -> None: ...
    UPDATES_FIELD_NUMBER: _ClassVar[int]
    DOMAIN_SNAPSHOT_ID_FIELD_NUMBER: _ClassVar[int]
    LOG_ENTRY_ID_FIELD_NUMBER: _ClassVar[int]
    updates: _containers.RepeatedCompositeFieldContainer[UpdateDomainStateRequest.StateUpdate]
    domain_snapshot_id: _common_types_pb2.SnapshotId
    log_entry_id: _common_types_pb2.LogEntryId
    def __init__(self, updates: _Optional[_Iterable[_Union[UpdateDomainStateRequest.StateUpdate, _Mapping]]] = ..., domain_snapshot_id: _Optional[_Union[_common_types_pb2.SnapshotId, _Mapping]] = ..., log_entry_id: _Optional[_Union[_common_types_pb2.LogEntryId, _Mapping]] = ...) -> None: ...

class UpdateDomainStateReply(_message.Message):
    __slots__ = ("exception",)
    class Exception(_message.Message):
        __slots__ = ("domain_does_not_exist", "invalid_snapshot", "state_flag_does_not_exist", "invalid_data")
        DOMAIN_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        INVALID_SNAPSHOT_FIELD_NUMBER: _ClassVar[int]
        STATE_FLAG_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        INVALID_DATA_FIELD_NUMBER: _ClassVar[int]
        domain_does_not_exist: _error_types_pb2.DomainDoesNotExist
        invalid_snapshot: _error_types_pb2.InvalidSnapshot
        state_flag_does_not_exist: _error_types_pb2.StateFlagDoesNotExist
        invalid_data: _error_types_pb2.InvalidData
        def __init__(self, domain_does_not_exist: _Optional[_Union[_error_types_pb2.DomainDoesNotExist, _Mapping]] = ..., invalid_snapshot: _Optional[_Union[_error_types_pb2.InvalidSnapshot, _Mapping]] = ..., state_flag_does_not_exist: _Optional[_Union[_error_types_pb2.StateFlagDoesNotExist, _Mapping]] = ..., invalid_data: _Optional[_Union[_error_types_pb2.InvalidData, _Mapping]] = ...) -> None: ...
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    exception: UpdateDomainStateReply.Exception
    def __init__(self, exception: _Optional[_Union[UpdateDomainStateReply.Exception, _Mapping]] = ...) -> None: ...
