from fred_api.registry.keyset import keyset_common_types_pb2 as _keyset_common_types_pb2
from fred_api.registry import common_types_pb2 as _common_types_pb2
from fred_api.registry import error_types_pb2 as _error_types_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class KeysetHistoryRequest(_message.Message):
    __slots__ = ("keyset_id", "history")
    KEYSET_ID_FIELD_NUMBER: _ClassVar[int]
    HISTORY_FIELD_NUMBER: _ClassVar[int]
    keyset_id: _keyset_common_types_pb2.KeysetId
    history: _keyset_common_types_pb2.KeysetHistoryInterval
    def __init__(self, keyset_id: _Optional[_Union[_keyset_common_types_pb2.KeysetId, _Mapping]] = ..., history: _Optional[_Union[_keyset_common_types_pb2.KeysetHistoryInterval, _Mapping]] = ...) -> None: ...

class KeysetHistoryRecord(_message.Message):
    __slots__ = ("keyset_history_id", "valid_from", "log_entry_id")
    KEYSET_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
    VALID_FROM_FIELD_NUMBER: _ClassVar[int]
    LOG_ENTRY_ID_FIELD_NUMBER: _ClassVar[int]
    keyset_history_id: _keyset_common_types_pb2.KeysetHistoryId
    valid_from: _timestamp_pb2.Timestamp
    log_entry_id: _common_types_pb2.LogEntryId
    def __init__(self, keyset_history_id: _Optional[_Union[_keyset_common_types_pb2.KeysetHistoryId, _Mapping]] = ..., valid_from: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., log_entry_id: _Optional[_Union[_common_types_pb2.LogEntryId, _Mapping]] = ...) -> None: ...

class KeysetHistoryReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("keyset_id", "timeline", "valid_to")
        KEYSET_ID_FIELD_NUMBER: _ClassVar[int]
        TIMELINE_FIELD_NUMBER: _ClassVar[int]
        VALID_TO_FIELD_NUMBER: _ClassVar[int]
        keyset_id: _keyset_common_types_pb2.KeysetId
        timeline: _containers.RepeatedCompositeFieldContainer[KeysetHistoryRecord]
        valid_to: _timestamp_pb2.Timestamp
        def __init__(self, keyset_id: _Optional[_Union[_keyset_common_types_pb2.KeysetId, _Mapping]] = ..., timeline: _Optional[_Iterable[_Union[KeysetHistoryRecord, _Mapping]]] = ..., valid_to: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("keyset_does_not_exist", "invalid_history_interval")
        class InvalidHistoryInterval(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        KEYSET_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        INVALID_HISTORY_INTERVAL_FIELD_NUMBER: _ClassVar[int]
        keyset_does_not_exist: _error_types_pb2.KeysetDoesNotExist
        invalid_history_interval: KeysetHistoryReply.Exception.InvalidHistoryInterval
        def __init__(self, keyset_does_not_exist: _Optional[_Union[_error_types_pb2.KeysetDoesNotExist, _Mapping]] = ..., invalid_history_interval: _Optional[_Union[KeysetHistoryReply.Exception.InvalidHistoryInterval, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: KeysetHistoryReply.Data
    exception: KeysetHistoryReply.Exception
    def __init__(self, data: _Optional[_Union[KeysetHistoryReply.Data, _Mapping]] = ..., exception: _Optional[_Union[KeysetHistoryReply.Exception, _Mapping]] = ...) -> None: ...
