from fred_api.registry import common_types_pb2 as _common_types_pb2
from fred_api.registry import error_types_pb2 as _error_types_pb2
from fred_api.registry.keyset import keyset_common_types_pb2 as _keyset_common_types_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class KeysetStateRequest(_message.Message):
    __slots__ = ("keyset_id", "keyset_snapshot_id")
    KEYSET_ID_FIELD_NUMBER: _ClassVar[int]
    KEYSET_SNAPSHOT_ID_FIELD_NUMBER: _ClassVar[int]
    keyset_id: _keyset_common_types_pb2.KeysetId
    keyset_snapshot_id: _common_types_pb2.SnapshotId
    def __init__(self, keyset_id: _Optional[_Union[_keyset_common_types_pb2.KeysetId, _Mapping]] = ..., keyset_snapshot_id: _Optional[_Union[_common_types_pb2.SnapshotId, _Mapping]] = ...) -> None: ...

class KeysetState(_message.Message):
    __slots__ = ("flags",)
    class FlagsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: bool
        def __init__(self, key: _Optional[str] = ..., value: bool = ...) -> None: ...
    FLAGS_FIELD_NUMBER: _ClassVar[int]
    flags: _containers.ScalarMap[str, bool]
    def __init__(self, flags: _Optional[_Mapping[str, bool]] = ...) -> None: ...

class KeysetStateReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("keyset_id", "state", "snapshot_id")
        KEYSET_ID_FIELD_NUMBER: _ClassVar[int]
        STATE_FIELD_NUMBER: _ClassVar[int]
        SNAPSHOT_ID_FIELD_NUMBER: _ClassVar[int]
        keyset_id: _keyset_common_types_pb2.KeysetId
        state: KeysetState
        snapshot_id: _common_types_pb2.SnapshotId
        def __init__(self, keyset_id: _Optional[_Union[_keyset_common_types_pb2.KeysetId, _Mapping]] = ..., state: _Optional[_Union[KeysetState, _Mapping]] = ..., snapshot_id: _Optional[_Union[_common_types_pb2.SnapshotId, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("keyset_does_not_exist", "invalid_data", "invalid_snapshot")
        KEYSET_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        INVALID_DATA_FIELD_NUMBER: _ClassVar[int]
        INVALID_SNAPSHOT_FIELD_NUMBER: _ClassVar[int]
        keyset_does_not_exist: _error_types_pb2.KeysetDoesNotExist
        invalid_data: _error_types_pb2.InvalidData
        invalid_snapshot: _error_types_pb2.InvalidSnapshot
        def __init__(self, keyset_does_not_exist: _Optional[_Union[_error_types_pb2.KeysetDoesNotExist, _Mapping]] = ..., invalid_data: _Optional[_Union[_error_types_pb2.InvalidData, _Mapping]] = ..., invalid_snapshot: _Optional[_Union[_error_types_pb2.InvalidSnapshot, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: KeysetStateReply.Data
    exception: KeysetStateReply.Exception
    def __init__(self, data: _Optional[_Union[KeysetStateReply.Data, _Mapping]] = ..., exception: _Optional[_Union[KeysetStateReply.Exception, _Mapping]] = ...) -> None: ...
