from fred_api.registry import common_types_pb2 as _common_types_pb2
from fred_api.registry import error_types_pb2 as _error_types_pb2
from fred_api.registry.nsset import nsset_common_types_pb2 as _nsset_common_types_pb2
from fred_api.registry.registrar import registrar_common_types_pb2 as _registrar_common_types_pb2
from google.protobuf import empty_pb2 as _empty_pb2
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class AddNssetAuthInfoRequest(_message.Message):
    __slots__ = ("nsset_id", "nsset_snapshot_id", "auth_info", "generate", "ttl", "by_registrar", "log_entry_id")
    NSSET_ID_FIELD_NUMBER: _ClassVar[int]
    NSSET_SNAPSHOT_ID_FIELD_NUMBER: _ClassVar[int]
    AUTH_INFO_FIELD_NUMBER: _ClassVar[int]
    GENERATE_FIELD_NUMBER: _ClassVar[int]
    TTL_FIELD_NUMBER: _ClassVar[int]
    BY_REGISTRAR_FIELD_NUMBER: _ClassVar[int]
    LOG_ENTRY_ID_FIELD_NUMBER: _ClassVar[int]
    nsset_id: _nsset_common_types_pb2.NssetId
    nsset_snapshot_id: _common_types_pb2.SnapshotId
    auth_info: str
    generate: _empty_pb2.Empty
    ttl: int
    by_registrar: _registrar_common_types_pb2.RegistrarHandle
    log_entry_id: _common_types_pb2.LogEntryId
    def __init__(self, nsset_id: _Optional[_Union[_nsset_common_types_pb2.NssetId, _Mapping]] = ..., nsset_snapshot_id: _Optional[_Union[_common_types_pb2.SnapshotId, _Mapping]] = ..., auth_info: _Optional[str] = ..., generate: _Optional[_Union[_empty_pb2.Empty, _Mapping]] = ..., ttl: _Optional[int] = ..., by_registrar: _Optional[_Union[_registrar_common_types_pb2.RegistrarHandle, _Mapping]] = ..., log_entry_id: _Optional[_Union[_common_types_pb2.LogEntryId, _Mapping]] = ...) -> None: ...

class AddNssetAuthInfoReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("auth_info",)
        AUTH_INFO_FIELD_NUMBER: _ClassVar[int]
        auth_info: str
        def __init__(self, auth_info: _Optional[str] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("nsset_does_not_exist", "registrar_does_not_exist", "invalid_snapshot", "invalid_data")
        NSSET_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        REGISTRAR_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        INVALID_SNAPSHOT_FIELD_NUMBER: _ClassVar[int]
        INVALID_DATA_FIELD_NUMBER: _ClassVar[int]
        nsset_does_not_exist: _error_types_pb2.NssetDoesNotExist
        registrar_does_not_exist: _error_types_pb2.RegistrarDoesNotExist
        invalid_snapshot: _error_types_pb2.InvalidSnapshot
        invalid_data: _error_types_pb2.InvalidData
        def __init__(self, nsset_does_not_exist: _Optional[_Union[_error_types_pb2.NssetDoesNotExist, _Mapping]] = ..., registrar_does_not_exist: _Optional[_Union[_error_types_pb2.RegistrarDoesNotExist, _Mapping]] = ..., invalid_snapshot: _Optional[_Union[_error_types_pb2.InvalidSnapshot, _Mapping]] = ..., invalid_data: _Optional[_Union[_error_types_pb2.InvalidData, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: AddNssetAuthInfoReply.Data
    exception: AddNssetAuthInfoReply.Exception
    def __init__(self, data: _Optional[_Union[AddNssetAuthInfoReply.Data, _Mapping]] = ..., exception: _Optional[_Union[AddNssetAuthInfoReply.Exception, _Mapping]] = ...) -> None: ...
