from fred_api.registry import common_types_pb2 as _common_types_pb2
from fred_api.registry import error_types_pb2 as _error_types_pb2
from fred_api.registry.nsset import nsset_common_types_pb2 as _nsset_common_types_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class NssetStateRequest(_message.Message):
    __slots__ = ("nsset_id", "nsset_snapshot_id")
    NSSET_ID_FIELD_NUMBER: _ClassVar[int]
    NSSET_SNAPSHOT_ID_FIELD_NUMBER: _ClassVar[int]
    nsset_id: _nsset_common_types_pb2.NssetId
    nsset_snapshot_id: _common_types_pb2.SnapshotId
    def __init__(self, nsset_id: _Optional[_Union[_nsset_common_types_pb2.NssetId, _Mapping]] = ..., nsset_snapshot_id: _Optional[_Union[_common_types_pb2.SnapshotId, _Mapping]] = ...) -> None: ...

class NssetState(_message.Message):
    __slots__ = ("flags",)
    class FlagsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: bool
        def __init__(self, key: _Optional[str] = ..., value: bool = ...) -> None: ...
    FLAGS_FIELD_NUMBER: _ClassVar[int]
    flags: _containers.ScalarMap[str, bool]
    def __init__(self, flags: _Optional[_Mapping[str, bool]] = ...) -> None: ...

class NssetStateReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("nsset_id", "state", "snapshot_id")
        NSSET_ID_FIELD_NUMBER: _ClassVar[int]
        STATE_FIELD_NUMBER: _ClassVar[int]
        SNAPSHOT_ID_FIELD_NUMBER: _ClassVar[int]
        nsset_id: _nsset_common_types_pb2.NssetId
        state: NssetState
        snapshot_id: _common_types_pb2.SnapshotId
        def __init__(self, nsset_id: _Optional[_Union[_nsset_common_types_pb2.NssetId, _Mapping]] = ..., state: _Optional[_Union[NssetState, _Mapping]] = ..., snapshot_id: _Optional[_Union[_common_types_pb2.SnapshotId, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("nsset_does_not_exist", "invalid_data", "invalid_snapshot")
        NSSET_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        INVALID_DATA_FIELD_NUMBER: _ClassVar[int]
        INVALID_SNAPSHOT_FIELD_NUMBER: _ClassVar[int]
        nsset_does_not_exist: _error_types_pb2.NssetDoesNotExist
        invalid_data: _error_types_pb2.InvalidData
        invalid_snapshot: _error_types_pb2.InvalidSnapshot
        def __init__(self, nsset_does_not_exist: _Optional[_Union[_error_types_pb2.NssetDoesNotExist, _Mapping]] = ..., invalid_data: _Optional[_Union[_error_types_pb2.InvalidData, _Mapping]] = ..., invalid_snapshot: _Optional[_Union[_error_types_pb2.InvalidSnapshot, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: NssetStateReply.Data
    exception: NssetStateReply.Exception
    def __init__(self, data: _Optional[_Union[NssetStateReply.Data, _Mapping]] = ..., exception: _Optional[_Union[NssetStateReply.Exception, _Mapping]] = ...) -> None: ...
